package com.onresolve.jira.groovy.test;

import org.junit.Test;

import javax.script.Bindings;
import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.SimpleBindings;
import java.util.HashMap;
import java.util.Map;

public class ScriptBindingsTests {

    @Test
    public void testLongRunningScript() throws Exception {

        ScriptEngineManager mgr = new ScriptEngineManager();
        ScriptEngine engine = mgr.getEngineByName("groovy");
        System.out.println(engine);

        String script1 = "10.times {\n" +
                "    println (\"thread1: $x\")\n" +
                "    Thread.sleep 1000\n" +
                "}";

        // test we get the same script engine each time
        Map<String, Integer> inputs = new HashMap<String, Integer>();
        inputs.put("x", 1);

        Bindings bindings1 = new SimpleBindings();
        bindings1.put("x", 1);

        // observe that the number printed does not change from 1 to 2
        RunnableThread thread = new RunnableThread("thread", engine, script1, bindings1);
        thread.start();

        Thread.sleep (5000);

        // thread.join(8000);

        Bindings bindings2 = new SimpleBindings();
        bindings2.put("x", 2);

        String script2 = "println \"thread2: $x\"";
        RunnableThread thread2 = new RunnableThread("thread2", engine, script1, bindings2);
        thread2.start();

        thread.join();

    }

    class RunnableThread extends Thread {

        Thread runner;
        ScriptEngine engine;
        Bindings binding;
        String script;

        public RunnableThread() {
        }
        public RunnableThread(String threadName, ScriptEngine engine, String script, Bindings binding) {
            System.out.println(this.getName());
            this.engine = engine;
            this.binding = binding;
            this.script = script;
        }
        public void run() {
            //Display info about this particular thread
            try {
                engine.eval(script, binding);
            } catch (Exception e) {
                e.printStackTrace();
            }
            System.out.println(Thread.currentThread() + " thread exiting");
        }
    }
}
