package com.onresolve.jira.groovy.test

import com.atlassian.jira.issue.comments.Comment
import org.apache.log4j.Category
import org.junit.After
import org.junit.Before
import org.junit.Test
import static junit.framework.Assert.assertNotNull

/**
 * User: jechlin2
 * Date: 13-Dec-2010
 * Time: 17:36:00
 */
class TestFireEventWhen extends BaseSubTaskTest {

    Category log = Category.getInstance(this.class)

    @Before
    public void setUp() {
        log.debug ("setUp")

        log.debug ("issueType: ${issueType.getName()}")
        assertNotNull(project)

        issue = componentManager.getIssueFactory().getIssue()
        issue.setProject(project.getGenericValue())

        issue.setSummary "my summary"
        issue.setReporterId "admin"
        issue.setIssueType issueType.getGenericValue()
        issue.setPriorityId('2')
        issueManager.createIssue(adminUser, issue);
        log.debug ("Created issue: $issue")

    }


    @After
    public void tearDown() {
        deleteIssue(issue);
    }

    @Test
    public void testSubTasksResolved() {
        // test with no sub-tasks
        Comment comment = componentManager.getCommentManager().create(issue, adminUser.name, "My comment", false)

        // doesn't work
        // runner.run(FireEventWhen.class.getName(), [transientVars: [issue: issue, commentValue: comment], Event: '2', username:adminUser.name] as Map<String, Object>)

    }


}
