(function ($) {
    $(function() {
        var codeMirrorEditor = [];

        $("#previewIssue").click(function () {
            $("#preview").empty();
            $("#spinner").show();

            $.post(AJS.params.baseURL + "/plugins/servlet/com.onresolve.ScriptedFieldPreviewServlet",
                {
                    cfid: $("#cfid").val(),
                    fieldLayoutId: $("#fcs").val(),
                    previewIssueKey: $("#previewIssueKey").val(),
                    scriptFile: $("#scriptFile").val(),
                    script: codeMirrorEditor[0].getValue(),
                    customTemplate: codeMirrorEditor[1].getValue(),
                    modelTemplate: $("#modelTemplate").val()
                },
                function (data) {
                    $("#spinner").hide();
                    $("#preview").empty().append(data["output"]);
                    $("#errors").empty().append(data["errors"]);
                }
            ).error(function () {
                $("#spinner").hide();
                // console.log("error");
            });
        });

        $(".codeSnippet").each(function (el) {
            var codeMirrorOptions = {
                lineNumbers: true,
                matchBrackets: true,
                mode: "text/x-java",
                indentUnit: 4,
                enterMode: "keep",
                electricChars: false
            };
            if ($(this).hasClass("readonly")) {
                codeMirrorOptions["readOnly"] = true;
            }
            codeMirrorEditor.push(CodeMirror.fromTextArea($(this)[0], codeMirrorOptions));
        });

        $("#modelTemplate").change(function () {
            if ($(this).val() == "custom") {
                $("#customTemplate_container").slideDown('slow', null);
                if (codeMirrorEditor[1].getValue() == "") {
                    codeMirrorEditor[1].setValue("##Example\n$!value");
                }
            }
            else {
                $("#customTemplate_container").slideUp('slow', null);
            }
        });

        if ($("#modelTemplate").val() == "custom") {
            $("#customTemplate_container").show();
        }
        else {
            $("#customTemplate_container").hide();
        }
    });

}) (AJS.$);

